unit SubUnit;

interface
 uses urs232,CRS,SysUtils,Dialogs;

type
     TComPort  =  class(TCommPortDriver)
                  end;

     TPaket    =  packed record
     BeginFlag  : byte;
     Adress     : byte;
     TypeFrame  : byte;
     LengthData : byte;
     Data       : array[1..127] of char;
     CRS        : byte;
     EndFlag    : byte;
                  end;

const
      Flag        = $F9;
      EA          = 1;
      CR          = 2;
      PF          = 16;
      tpSABM      = 47;
      tpUIH       = 239;
      tpDISC      = 67;
      tpUA        = 99;

      cmOpen      = 'AT+CMUX=0';
      cmClose     = #195;

      MaxInfoSize = 97;

      Channel0     = 0;
      Channel1     = 1;
      Channel2     = 2;
      Channel3     = 3;

      ComTimeOut  = 400; {time in ms}

      BufSize     = 5000;




function  OpenCom(N,B:byte):boolean;
procedure CloseCom;
procedure ClearBuf;
procedure ReadBuf;
function  DataInCom:integer;

procedure ReadChar;

function  OKIn:boolean;
function  PaketIn:boolean;

procedure WriteAT(s:string);

procedure CloseMux;
procedure OpenMux;
procedure OpenChanel(Chanal:byte);
procedure SendData(Chanal:byte;s:string);


var
    ComPort        : TComPort;
    SendPaket      : TPaket;
    bp             : array[1..BufSize] of char;
    bpi            : word;
    PaketData      : string;
    CurrentChannel : byte;
    TypePaket      : byte;


implementation


procedure ClearBuf;
begin
 bpi:=0;
 FillChar(bp[1],BufSize,#0);
end;


function DataInCom:integer;
var i,j:integer;
begin
 DataInBuffer(ComPort.GetHandle,i,j);
 Result:=i;
end;


procedure ReadBuf;
var s   : string;
    i,j : integer;
begin
  DataInBuffer(ComPort.GetHandle,i,j);
  While (i>0) do
    begin
    if bpi<BufSize then inc(bpi);
    ComPort.ReadString(s,1);
    bp[bpi]:=s[1];
    dec(i);
    end;
end;


function OKIn:boolean;
 var i:word;
begin
 Result:=false;

   for i:=1 to bpi   do
                     if (bp[i]  ='O') and
                        (bp[i+1]='K')
                     then
                     begin
                     Result:=true;
                     exit
                     end;
end;


procedure ReadChar;
 var i,j : integer;
       s : string;
begin
  DataInBuffer(ComPort.GetHandle,i,j);
  if i>0 then 
    begin
    if bpi<BufSize then inc(bpi);
    ComPort.ReadString(s,1);
    bp[bpi]:=s[1];
    end;
end;


function  PaketIn:boolean;
label more,found;
 var i,j,n : word;
     size  : byte;
     sum   : byte;
begin
Result:=false;

n:=0;
more:

for i:=1+n to bpi-3 do
     if bp[i]=char(Flag) then
                         begin
                         n:=i;
                         goto found;
                         end;
exit;
found:


size:=( ord(bp[n+3]) shr 1);
if (bpi+(size+4+2)>BufSize)or(bpi<(size+4+2)) then exit;


sum:=CalcCrc(@bp[n+1],3);
 if sum<>ord(bp[n+size+3+1]) then goto more;


 TypePaket:=ord(bp[i+2]) and (not PF);
 CurrentChannel:=ord(bp[i+1]) shr 2;


 SetLength(PaketData,size);
 for i:=1 to size do PaketData[i]:=bp[i+4]; 

 Result:=true;

end;


function OpenCom(N,B:byte):boolean;
begin
 OpenCom:=true;

 ComPort:=TComPort.Create(nil);

 case n of
 0:ComPort.SetComPort(pnCom1);
 1:ComPort.SetComPort(pnCom2);
 2:ComPort.SetComPort(pnCom3);
 3:ComPort.SetComPort(pnCom4);
 end;

 case b of
 0:ComPort.ComPortSpeed:=br110;
 1:ComPort.ComPortSpeed:=br300;
 2:ComPort.ComPortSpeed:=br600;
 3:ComPort.ComPortSpeed:=br1200;
 4:ComPort.ComPortSpeed:=br2400;
 5:ComPort.ComPortSpeed:=br4800;
 6:ComPort.ComPortSpeed:=br9600;
 7:ComPort.ComPortSpeed:=br14400;
 8:ComPort.ComPortSpeed:=br19200;
 9:ComPort.ComPortSpeed:=br38400;
10:ComPort.ComPortSpeed:=br56000;
11:ComPort.ComPortSpeed:=br57600;
12:ComPort.ComPortSpeed:=br115200;
 end;

 ComPort.Connect;

 if not ComPort.SendData(@N,1) then
                               begin
                               ComPort.Destroy;
                               ComPort:=nil;
                               OpenCom:=false;
                               end;
end;


procedure CloseCom;
begin
 if ComPort<>nil then
                 begin
                 ComPort.Destroy;
                 ComPort:=nil;
                 end;
end;


procedure WriteAT(s:string);
begin
 ComPort.SendString(s+#13);
end;


procedure OpenChanel(Chanal:byte);
 var Sum : byte;
begin
 SendPaket.BeginFlag:=Flag;

 SendPaket.Adress:=EA+CR+(Chanal shl 2);
 SendPaket.TypeFrame:=tpSABM+PF;
 SendPaket.LengthData:=EA;

 Sum:=CalcCrc(@SendPaket.Adress,3);
 SendPaket.CRS:=Sum;

 SendPaket.EndFlag:=Flag;

 ComPort.SendData(@Sendpaket.BeginFlag,4);
 ComPort.SendData(@Sendpaket.CRS,2);
end;


procedure OpenMUX;
begin
 WriteAT(cmOpen);
 OpenChanel(Channel0);
end;


procedure CloseMux;
 var Sum : byte;
begin
 SendPaket.BeginFlag:=Flag;

 SendPaket.Adress:=EA+CR;
 SendPaket.TypeFrame:=tpUIH+PF;
 SendPaket.LengthData:=EA+(1 shl 1);

 Sum:=CalcCrc(@SendPaket.Adress,3);
 SendPaket.CRS:=Sum;

 SendPaket.Data[1]:=cmClose;

 SendPaket.EndFlag:=Flag;

 ComPort.SendData(@Sendpaket.BeginFlag,4+1);
 ComPort.SendData(@Sendpaket.CRS,2);
end;


procedure SendData(Chanal:byte;s:string);
 var Sum : byte;
     i,n : byte;
begin
 n:=length(s);
 if n>MaxInfoSize then exit;

 SendPaket.BeginFlag:=Flag;

 SendPaket.Adress:=EA+CR+(Chanal shl 2);
 SendPaket.TypeFrame:=tpUIH+PF;            //PF?
 SendPaket.LengthData:=EA+(n shl 1);

 for i:=1 to n do SendPaket.Data[i]:=s[i];

 Sum:=CalcCrc(@SendPaket.Adress,3);
 SendPaket.CRS:=Sum;

 SendPaket.EndFlag:=Flag;

 ComPort.SendData(@Sendpaket.BeginFlag,4+n);
 ComPort.SendData(@Sendpaket.CRS,2);
end;

end.
